AuthenticationController = require '../Authentication/AuthenticationController'
EditorController = require '../Editor/EditorController'
Settings = require 'settings-sharelatex'
logger = require 'logger-sharelatex'

module.exports = LinkedFilesController = {
	Agents: {
		url: require('./UrlAgent'),
		project_file: require('./ProjectFileAgent')
	}

	createLinkedFile: (req, res, next) ->
		{project_id} = req.params
		{name, provider, data, parent_folder_id} = req.body
		user_id = AuthenticationController.getLoggedInUserId(req)
		logger.log {project_id, name, provider, data, parent_folder_id, user_id}, 'create linked file request'

		if !LinkedFilesController.Agents.hasOwnProperty(provider)
			return res.send(400)
		unless provider in Settings.enabledLinkedFileTypes
			return res.send(400)
		Agent = LinkedFilesController.Agents[provider]

		linkedFileData = Agent.sanitizeData(data)
		linkedFileData.provider = provider
		Agent.checkAuth project_id, linkedFileData, user_id, (err, allowed) ->
			return Agent.handleError(err, req, res, next) if err?
			return res.sendStatus(403) if !allowed
			Agent.decorateLinkedFileData linkedFileData, (err, newLinkedFileData) ->
				return Agent.handleError(err) if err?
				linkedFileData = newLinkedFileData
				Agent.writeIncomingFileToDisk project_id, linkedFileData, user_id, (error, fsPath) ->
					if error?
						logger.error {err: error, project_id, name, linkedFileData, parent_folder_id, user_id}, 'error writing linked file to disk'
						return Agent.handleError(error, req, res, next)
					EditorController.upsertFile project_id, parent_folder_id, name, fsPath, linkedFileData, "upload", user_id, (error, file) ->
						return next(error) if error?
						res.json(new_file_id: file._id) # created
	}
